/* Generated by Frama-C */
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"
#include "stdlib.h"
extern  __attribute__((__FC_BUILTIN__)) int __e_acsl_sound_verdict;

struct temporal_t {
   char *p ;
   char *q ;
};
struct larger_t {
   char *p ;
   char *q ;
   struct temporal_t t ;
};
typedef struct temporal_t temporal;
typedef struct larger_t larger;
int main(void)
{
  int __retres;
  temporal t1;
  temporal t2;
  temporal *tp;
  temporal tarr[2];
  larger l;
  larger *lp;
  larger larr[2];
  __e_acsl_memory_init((int *)0,(char ***)0,(size_t)8);
  __e_acsl_store_block((void *)(larr),(size_t)64);
  __e_acsl_store_block((void *)(& lp),(size_t)8);
  __e_acsl_store_block((void *)(& l),(size_t)32);
  __e_acsl_store_block((void *)(tarr),(size_t)32);
  __e_acsl_store_block((void *)(& t2),(size_t)16);
  __e_acsl_store_block((void *)(& t1),(size_t)16);
  int a = 1;
  __e_acsl_store_block((void *)(& a),(size_t)4);
  __e_acsl_full_init((void *)(& a));
  int b = 2;
  __e_acsl_initialize((void *)(& t1.p),sizeof(char *));
  __e_acsl_temporal_store_nblock((void *)(& t1.p),(void *)(& a));
  t1.p = (char *)(& a);
  __e_acsl_initialize((void *)(& t1.q),sizeof(char *));
  __e_acsl_temporal_store_nreferent((void *)(& t1.q),(void *)(& t1.p));
  t1.q = t1.p;
  {
    int __gen_e_acsl_initialized;
    int __gen_e_acsl_and;
    int __gen_e_acsl_and_3;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"&t1.p",
                                 (void *)(& t1.p));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                   "sizeof(char *)",0,sizeof(char *));
    __gen_e_acsl_initialized = __e_acsl_initialized((void *)(& t1.p),
                                                    sizeof(char *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                 "\\initialized(&t1.p)",0,
                                 __gen_e_acsl_initialized);
    if (__gen_e_acsl_initialized) {
      int __gen_e_acsl_valid;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"t1.p",
                                   (void *)t1.p);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                     "sizeof(char)",0,sizeof(char));
      __gen_e_acsl_valid = __e_acsl_valid((void *)t1.p,sizeof(char),
                                          (void *)t1.p,(void *)(& t1.p));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                   "\\valid(t1.p)",0,__gen_e_acsl_valid);
      __gen_e_acsl_and = __gen_e_acsl_valid;
    }
    else __gen_e_acsl_and = 0;
    if (__gen_e_acsl_and) {
      int __gen_e_acsl_initialized_2;
      int __gen_e_acsl_and_2;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"&t1.q",
                                   (void *)(& t1.q));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                     "sizeof(char *)",0,sizeof(char *));
      __gen_e_acsl_initialized_2 = __e_acsl_initialized((void *)(& t1.q),
                                                        sizeof(char *));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                   "\\initialized(&t1.q)",0,
                                   __gen_e_acsl_initialized_2);
      if (__gen_e_acsl_initialized_2) {
        int __gen_e_acsl_valid_2;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"t1.q",
                                     (void *)t1.q);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                       "sizeof(char)",0,sizeof(char));
        __gen_e_acsl_valid_2 = __e_acsl_valid((void *)t1.q,sizeof(char),
                                              (void *)t1.q,(void *)(& t1.q));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                     "\\valid(t1.q)",0,__gen_e_acsl_valid_2);
        __gen_e_acsl_and_2 = __gen_e_acsl_valid_2;
      }
      else __gen_e_acsl_and_2 = 0;
      __gen_e_acsl_and_3 = __gen_e_acsl_and_2;
    }
    else __gen_e_acsl_and_3 = 0;
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "\\valid(t1.p) && \\valid(t1.q)";
    __gen_e_acsl_assert_data.file = "tests/temporal/t_struct.c";
    __gen_e_acsl_assert_data.fct = "main";
    __gen_e_acsl_assert_data.line = 30;
    __e_acsl_assert(__gen_e_acsl_and_3,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert \valid(t1.p) && \valid(t1.q); */ ;
  {
    int __gen_e_acsl_initialized_3;
    int __gen_e_acsl_and_4;
    int __gen_e_acsl_and_6;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"&t2.p",
                                 (void *)(& t2.p));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                   "sizeof(char *)",0,sizeof(char *));
    __gen_e_acsl_initialized_3 = __e_acsl_initialized((void *)(& t2.p),
                                                      sizeof(char *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                 "\\initialized(&t2.p)",0,
                                 __gen_e_acsl_initialized_3);
    if (__gen_e_acsl_initialized_3) {
      int __gen_e_acsl_valid_3;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"t2.p",
                                   (void *)t2.p);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                     "sizeof(char)",0,sizeof(char));
      __gen_e_acsl_valid_3 = __e_acsl_valid((void *)t2.p,sizeof(char),
                                            (void *)t2.p,(void *)(& t2.p));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                   "\\valid(t2.p)",0,__gen_e_acsl_valid_3);
      __gen_e_acsl_and_4 = __gen_e_acsl_valid_3;
    }
    else __gen_e_acsl_and_4 = 0;
    if (! __gen_e_acsl_and_4) {
      int __gen_e_acsl_initialized_4;
      int __gen_e_acsl_and_5;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"&t2.q",
                                   (void *)(& t2.q));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                     "sizeof(char *)",0,sizeof(char *));
      __gen_e_acsl_initialized_4 = __e_acsl_initialized((void *)(& t2.q),
                                                        sizeof(char *));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                   "\\initialized(&t2.q)",0,
                                   __gen_e_acsl_initialized_4);
      if (__gen_e_acsl_initialized_4) {
        int __gen_e_acsl_valid_4;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"t2.q",
                                     (void *)t2.q);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                       "sizeof(char)",0,sizeof(char));
        __gen_e_acsl_valid_4 = __e_acsl_valid((void *)t2.q,sizeof(char),
                                              (void *)t2.q,(void *)(& t2.q));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                     "\\valid(t2.q)",0,__gen_e_acsl_valid_4);
        __gen_e_acsl_and_5 = __gen_e_acsl_valid_4;
      }
      else __gen_e_acsl_and_5 = 0;
      __gen_e_acsl_and_6 = ! __gen_e_acsl_and_5;
    }
    else __gen_e_acsl_and_6 = 0;
    __gen_e_acsl_assert_data_2.blocking = 1;
    __gen_e_acsl_assert_data_2.kind = "Assertion";
    __gen_e_acsl_assert_data_2.pred_txt = "!\\valid(t2.p) && !\\valid(t2.q)";
    __gen_e_acsl_assert_data_2.file = "tests/temporal/t_struct.c";
    __gen_e_acsl_assert_data_2.fct = "main";
    __gen_e_acsl_assert_data_2.line = 31;
    __e_acsl_assert(__gen_e_acsl_and_6,& __gen_e_acsl_assert_data_2);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
  }
  /*@ assert !\valid(t2.p) && !\valid(t2.q); */ ;
  __e_acsl_full_init((void *)(& t2));
  __e_acsl_temporal_memcpy((void *)(& t2),(void *)(& t1),(size_t)16);
  t2 = t1;
  {
    int __gen_e_acsl_initialized_5;
    int __gen_e_acsl_and_7;
    int __gen_e_acsl_and_9;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_3 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"&t2.p",
                                 (void *)(& t2.p));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                   "sizeof(char *)",0,sizeof(char *));
    __gen_e_acsl_initialized_5 = __e_acsl_initialized((void *)(& t2.p),
                                                      sizeof(char *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,
                                 "\\initialized(&t2.p)",0,
                                 __gen_e_acsl_initialized_5);
    if (__gen_e_acsl_initialized_5) {
      int __gen_e_acsl_valid_5;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"t2.p",
                                   (void *)t2.p);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                     "sizeof(char)",0,sizeof(char));
      __gen_e_acsl_valid_5 = __e_acsl_valid((void *)t2.p,sizeof(char),
                                            (void *)t2.p,(void *)(& t2.p));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,
                                   "\\valid(t2.p)",0,__gen_e_acsl_valid_5);
      __gen_e_acsl_and_7 = __gen_e_acsl_valid_5;
    }
    else __gen_e_acsl_and_7 = 0;
    if (__gen_e_acsl_and_7) {
      int __gen_e_acsl_initialized_6;
      int __gen_e_acsl_and_8;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"&t2.q",
                                   (void *)(& t2.q));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                     "sizeof(char *)",0,sizeof(char *));
      __gen_e_acsl_initialized_6 = __e_acsl_initialized((void *)(& t2.q),
                                                        sizeof(char *));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,
                                   "\\initialized(&t2.q)",0,
                                   __gen_e_acsl_initialized_6);
      if (__gen_e_acsl_initialized_6) {
        int __gen_e_acsl_valid_6;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"t2.q",
                                     (void *)t2.q);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                       "sizeof(char)",0,sizeof(char));
        __gen_e_acsl_valid_6 = __e_acsl_valid((void *)t2.q,sizeof(char),
                                              (void *)t2.q,(void *)(& t2.q));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,
                                     "\\valid(t2.q)",0,__gen_e_acsl_valid_6);
        __gen_e_acsl_and_8 = __gen_e_acsl_valid_6;
      }
      else __gen_e_acsl_and_8 = 0;
      __gen_e_acsl_and_9 = __gen_e_acsl_and_8;
    }
    else __gen_e_acsl_and_9 = 0;
    __gen_e_acsl_assert_data_3.blocking = 1;
    __gen_e_acsl_assert_data_3.kind = "Assertion";
    __gen_e_acsl_assert_data_3.pred_txt = "\\valid(t2.p) && \\valid(t2.q)";
    __gen_e_acsl_assert_data_3.file = "tests/temporal/t_struct.c";
    __gen_e_acsl_assert_data_3.fct = "main";
    __gen_e_acsl_assert_data_3.line = 34;
    __e_acsl_assert(__gen_e_acsl_and_9,& __gen_e_acsl_assert_data_3);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_3);
  }
  /*@ assert \valid(t2.p) && \valid(t2.q); */ ;
  __e_acsl_initialize((void *)(& t2.p),sizeof(char *));
  __e_acsl_temporal_store_nblock((void *)(& t2.p),(void *)0);
  t2.p = (char *)0;
  __e_acsl_initialize((void *)(& t2.q),sizeof(char *));
  __e_acsl_temporal_reset_parameters();
  __e_acsl_temporal_reset_return();
  t2.q = (char *)malloc((unsigned long)4);
  __e_acsl_temporal_store_nblock((void *)(& t2.q),(void *)*(& t2.q));
  {
    int __gen_e_acsl_initialized_7;
    int __gen_e_acsl_and_10;
    int __gen_e_acsl_and_12;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_4 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_4,"&t2.p",
                                 (void *)(& t2.p));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_4,
                                   "sizeof(char *)",0,sizeof(char *));
    __gen_e_acsl_initialized_7 = __e_acsl_initialized((void *)(& t2.p),
                                                      sizeof(char *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_4,
                                 "\\initialized(&t2.p)",0,
                                 __gen_e_acsl_initialized_7);
    if (__gen_e_acsl_initialized_7) {
      int __gen_e_acsl_valid_7;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_4,"t2.p",
                                   (void *)t2.p);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_4,
                                     "sizeof(char)",0,sizeof(char));
      __gen_e_acsl_valid_7 = __e_acsl_valid((void *)t2.p,sizeof(char),
                                            (void *)t2.p,(void *)(& t2.p));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_4,
                                   "\\valid(t2.p)",0,__gen_e_acsl_valid_7);
      __gen_e_acsl_and_10 = __gen_e_acsl_valid_7;
    }
    else __gen_e_acsl_and_10 = 0;
    if (! __gen_e_acsl_and_10) {
      int __gen_e_acsl_initialized_8;
      int __gen_e_acsl_and_11;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_4,"&t2.q",
                                   (void *)(& t2.q));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_4,
                                     "sizeof(char *)",0,sizeof(char *));
      __gen_e_acsl_initialized_8 = __e_acsl_initialized((void *)(& t2.q),
                                                        sizeof(char *));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_4,
                                   "\\initialized(&t2.q)",0,
                                   __gen_e_acsl_initialized_8);
      if (__gen_e_acsl_initialized_8) {
        int __gen_e_acsl_valid_8;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_4,"t2.q",
                                     (void *)t2.q);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_4,
                                       "sizeof(char)",0,sizeof(char));
        __gen_e_acsl_valid_8 = __e_acsl_valid((void *)t2.q,sizeof(char),
                                              (void *)t2.q,(void *)(& t2.q));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_4,
                                     "\\valid(t2.q)",0,__gen_e_acsl_valid_8);
        __gen_e_acsl_and_11 = __gen_e_acsl_valid_8;
      }
      else __gen_e_acsl_and_11 = 0;
      __gen_e_acsl_and_12 = __gen_e_acsl_and_11;
    }
    else __gen_e_acsl_and_12 = 0;
    __gen_e_acsl_assert_data_4.blocking = 1;
    __gen_e_acsl_assert_data_4.kind = "Assertion";
    __gen_e_acsl_assert_data_4.pred_txt = "!\\valid(t2.p) && \\valid(t2.q)";
    __gen_e_acsl_assert_data_4.file = "tests/temporal/t_struct.c";
    __gen_e_acsl_assert_data_4.fct = "main";
    __gen_e_acsl_assert_data_4.line = 38;
    __e_acsl_assert(__gen_e_acsl_and_12,& __gen_e_acsl_assert_data_4);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_4);
  }
  /*@ assert !\valid(t2.p) && \valid(t2.q); */ ;
  __e_acsl_initialize((void *)(& l.t),sizeof(struct temporal_t));
  __e_acsl_temporal_memcpy((void *)(& l.t),(void *)(& t2),(size_t)16);
  l.t = t2;
  {
    int __gen_e_acsl_initialized_9;
    int __gen_e_acsl_and_13;
    int __gen_e_acsl_and_15;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_5 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_5,"&l.t.p",
                                 (void *)(& l.t.p));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_5,
                                   "sizeof(char *)",0,sizeof(char *));
    __gen_e_acsl_initialized_9 = __e_acsl_initialized((void *)(& l.t.p),
                                                      sizeof(char *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_5,
                                 "\\initialized(&l.t.p)",0,
                                 __gen_e_acsl_initialized_9);
    if (__gen_e_acsl_initialized_9) {
      int __gen_e_acsl_valid_9;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_5,"l.t.p",
                                   (void *)l.t.p);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_5,
                                     "sizeof(char)",0,sizeof(char));
      __gen_e_acsl_valid_9 = __e_acsl_valid((void *)l.t.p,sizeof(char),
                                            (void *)l.t.p,(void *)(& l.t.p));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_5,
                                   "\\valid(l.t.p)",0,__gen_e_acsl_valid_9);
      __gen_e_acsl_and_13 = __gen_e_acsl_valid_9;
    }
    else __gen_e_acsl_and_13 = 0;
    if (! __gen_e_acsl_and_13) {
      int __gen_e_acsl_initialized_10;
      int __gen_e_acsl_and_14;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_5,"&l.t.q",
                                   (void *)(& l.t.q));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_5,
                                     "sizeof(char *)",0,sizeof(char *));
      __gen_e_acsl_initialized_10 = __e_acsl_initialized((void *)(& l.t.q),
                                                         sizeof(char *));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_5,
                                   "\\initialized(&l.t.q)",0,
                                   __gen_e_acsl_initialized_10);
      if (__gen_e_acsl_initialized_10) {
        int __gen_e_acsl_valid_10;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_5,"l.t.q",
                                     (void *)l.t.q);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_5,
                                       "sizeof(char)",0,sizeof(char));
        __gen_e_acsl_valid_10 = __e_acsl_valid((void *)l.t.q,sizeof(char),
                                               (void *)l.t.q,
                                               (void *)(& l.t.q));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_5,
                                     "\\valid(l.t.q)",0,
                                     __gen_e_acsl_valid_10);
        __gen_e_acsl_and_14 = __gen_e_acsl_valid_10;
      }
      else __gen_e_acsl_and_14 = 0;
      __gen_e_acsl_and_15 = __gen_e_acsl_and_14;
    }
    else __gen_e_acsl_and_15 = 0;
    __gen_e_acsl_assert_data_5.blocking = 1;
    __gen_e_acsl_assert_data_5.kind = "Assertion";
    __gen_e_acsl_assert_data_5.pred_txt = "!\\valid(l.t.p) && \\valid(l.t.q)";
    __gen_e_acsl_assert_data_5.file = "tests/temporal/t_struct.c";
    __gen_e_acsl_assert_data_5.fct = "main";
    __gen_e_acsl_assert_data_5.line = 41;
    __e_acsl_assert(__gen_e_acsl_and_15,& __gen_e_acsl_assert_data_5);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_5);
  }
  /*@ assert !\valid(l.t.p) && \valid(l.t.q); */ ;
  __e_acsl_full_init((void *)(& lp));
  __e_acsl_temporal_store_nblock((void *)(& lp),(void *)(& l));
  lp = & l;
  {
    int __gen_e_acsl_initialized_11;
    int __gen_e_acsl_and_16;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_6 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_6,"&lp->t.p",
                                 (void *)(& lp->t.p));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_6,
                                   "sizeof(char *)",0,sizeof(char *));
    __gen_e_acsl_initialized_11 = __e_acsl_initialized((void *)(& lp->t.p),
                                                       sizeof(char *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_6,
                                 "\\initialized(&lp->t.p)",0,
                                 __gen_e_acsl_initialized_11);
    if (__gen_e_acsl_initialized_11) {
      int __gen_e_acsl_valid_read;
      int __gen_e_acsl_valid_11;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_6,"lp->t.p",
                                   (void *)lp->t.p);
      __e_acsl_assert_data_t __gen_e_acsl_assert_data_7 =
        {.values = (void *)0};
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_7,"&lp->t.p",
                                   (void *)(& lp->t.p));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_7,
                                     "sizeof(char *)",0,sizeof(char *));
      __gen_e_acsl_valid_read = __e_acsl_valid_read((void *)(& lp->t.p),
                                                    sizeof(char *),
                                                    (void *)(& lp->t.p),
                                                    (void *)0);
      __gen_e_acsl_assert_data_7.blocking = 1;
      __gen_e_acsl_assert_data_7.kind = "RTE";
      __gen_e_acsl_assert_data_7.pred_txt = "mem_access: \\valid_read(&lp->t.p)";
      __gen_e_acsl_assert_data_7.file = "tests/temporal/t_struct.c";
      __gen_e_acsl_assert_data_7.fct = "main";
      __gen_e_acsl_assert_data_7.line = 44;
      __e_acsl_assert(__gen_e_acsl_valid_read,& __gen_e_acsl_assert_data_7);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data_7);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_6,
                                     "sizeof(char)",0,sizeof(char));
      __gen_e_acsl_valid_11 = __e_acsl_valid((void *)lp->t.p,sizeof(char),
                                             (void *)lp->t.p,
                                             (void *)(& lp->t.p));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_6,
                                   "\\valid(lp->t.p)",0,
                                   __gen_e_acsl_valid_11);
      __gen_e_acsl_and_16 = __gen_e_acsl_valid_11;
    }
    else __gen_e_acsl_and_16 = 0;
    __gen_e_acsl_assert_data_6.blocking = 1;
    __gen_e_acsl_assert_data_6.kind = "Assertion";
    __gen_e_acsl_assert_data_6.pred_txt = "!\\valid(lp->t.p)";
    __gen_e_acsl_assert_data_6.file = "tests/temporal/t_struct.c";
    __gen_e_acsl_assert_data_6.fct = "main";
    __gen_e_acsl_assert_data_6.line = 44;
    __e_acsl_assert(! __gen_e_acsl_and_16,& __gen_e_acsl_assert_data_6);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_6);
  }
  /*@ assert !\valid(lp->t.p); */ ;
  __e_acsl_initialize((void *)(tarr),sizeof(temporal));
  __e_acsl_temporal_memcpy((void *)(tarr),(void *)(& t2),(size_t)16);
  tarr[0] = t2;
  {
    int __gen_e_acsl_initialized_12;
    int __gen_e_acsl_and_17;
    int __gen_e_acsl_and_19;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_8 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_8,"&tarr[0].p",
                                 (void *)(& tarr[0].p));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_8,
                                   "sizeof(char *)",0,sizeof(char *));
    __gen_e_acsl_initialized_12 = __e_acsl_initialized((void *)(& tarr[0].p),
                                                       sizeof(char *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_8,
                                 "\\initialized(&tarr[0].p)",0,
                                 __gen_e_acsl_initialized_12);
    if (__gen_e_acsl_initialized_12) {
      int __gen_e_acsl_valid_12;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_8,"tarr[0].p",
                                   (void *)tarr[0].p);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_8,
                                     "sizeof(char)",0,sizeof(char));
      __gen_e_acsl_valid_12 = __e_acsl_valid((void *)tarr[0].p,sizeof(char),
                                             (void *)tarr[0].p,
                                             (void *)(& tarr[0].p));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_8,
                                   "\\valid(tarr[0].p)",0,
                                   __gen_e_acsl_valid_12);
      __gen_e_acsl_and_17 = __gen_e_acsl_valid_12;
    }
    else __gen_e_acsl_and_17 = 0;
    if (! __gen_e_acsl_and_17) {
      int __gen_e_acsl_initialized_13;
      int __gen_e_acsl_and_18;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_8,"&tarr[0].q",
                                   (void *)(& tarr[0].q));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_8,
                                     "sizeof(char *)",0,sizeof(char *));
      __gen_e_acsl_initialized_13 = __e_acsl_initialized((void *)(& tarr[0].q),
                                                         sizeof(char *));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_8,
                                   "\\initialized(&tarr[0].q)",0,
                                   __gen_e_acsl_initialized_13);
      if (__gen_e_acsl_initialized_13) {
        int __gen_e_acsl_valid_13;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_8,
                                     "tarr[0].q",(void *)tarr[0].q);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_8,
                                       "sizeof(char)",0,sizeof(char));
        __gen_e_acsl_valid_13 = __e_acsl_valid((void *)tarr[0].q,
                                               sizeof(char),
                                               (void *)tarr[0].q,
                                               (void *)(& tarr[0].q));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_8,
                                     "\\valid(tarr[0].q)",0,
                                     __gen_e_acsl_valid_13);
        __gen_e_acsl_and_18 = __gen_e_acsl_valid_13;
      }
      else __gen_e_acsl_and_18 = 0;
      __gen_e_acsl_and_19 = __gen_e_acsl_and_18;
    }
    else __gen_e_acsl_and_19 = 0;
    __gen_e_acsl_assert_data_8.blocking = 1;
    __gen_e_acsl_assert_data_8.kind = "Assertion";
    __gen_e_acsl_assert_data_8.pred_txt = "!\\valid(tarr[0].p) && \\valid(tarr[0].q)";
    __gen_e_acsl_assert_data_8.file = "tests/temporal/t_struct.c";
    __gen_e_acsl_assert_data_8.fct = "main";
    __gen_e_acsl_assert_data_8.line = 47;
    __e_acsl_assert(__gen_e_acsl_and_19,& __gen_e_acsl_assert_data_8);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_8);
  }
  /*@ assert !\valid(tarr[0].p) && \valid(tarr[0].q); */ ;
  __e_acsl_initialize((void *)(larr),sizeof(larger));
  __e_acsl_temporal_memcpy((void *)(larr),(void *)(& l),(size_t)32);
  larr[0] = l;
  {
    int __gen_e_acsl_initialized_14;
    int __gen_e_acsl_and_20;
    int __gen_e_acsl_and_22;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_9 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_9,"&larr[0].t.p",
                                 (void *)(& larr[0].t.p));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_9,
                                   "sizeof(char *)",0,sizeof(char *));
    __gen_e_acsl_initialized_14 = __e_acsl_initialized((void *)(& larr[0].t.p),
                                                       sizeof(char *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_9,
                                 "\\initialized(&larr[0].t.p)",0,
                                 __gen_e_acsl_initialized_14);
    if (__gen_e_acsl_initialized_14) {
      int __gen_e_acsl_valid_14;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_9,
                                   "larr[0].t.p",(void *)larr[0].t.p);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_9,
                                     "sizeof(char)",0,sizeof(char));
      __gen_e_acsl_valid_14 = __e_acsl_valid((void *)larr[0].t.p,
                                             sizeof(char),
                                             (void *)larr[0].t.p,
                                             (void *)(& larr[0].t.p));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_9,
                                   "\\valid(larr[0].t.p)",0,
                                   __gen_e_acsl_valid_14);
      __gen_e_acsl_and_20 = __gen_e_acsl_valid_14;
    }
    else __gen_e_acsl_and_20 = 0;
    if (! __gen_e_acsl_and_20) {
      int __gen_e_acsl_initialized_15;
      int __gen_e_acsl_and_21;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_9,
                                   "&larr[0].t.q",(void *)(& larr[0].t.q));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_9,
                                     "sizeof(char *)",0,sizeof(char *));
      __gen_e_acsl_initialized_15 = __e_acsl_initialized((void *)(& larr[0].t.q),
                                                         sizeof(char *));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_9,
                                   "\\initialized(&larr[0].t.q)",0,
                                   __gen_e_acsl_initialized_15);
      if (__gen_e_acsl_initialized_15) {
        int __gen_e_acsl_valid_15;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_9,
                                     "larr[0].t.q",(void *)larr[0].t.q);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_9,
                                       "sizeof(char)",0,sizeof(char));
        __gen_e_acsl_valid_15 = __e_acsl_valid((void *)larr[0].t.q,
                                               sizeof(char),
                                               (void *)larr[0].t.q,
                                               (void *)(& larr[0].t.q));
        __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_9,
                                     "\\valid(larr[0].t.q)",0,
                                     __gen_e_acsl_valid_15);
        __gen_e_acsl_and_21 = __gen_e_acsl_valid_15;
      }
      else __gen_e_acsl_and_21 = 0;
      __gen_e_acsl_and_22 = __gen_e_acsl_and_21;
    }
    else __gen_e_acsl_and_22 = 0;
    __gen_e_acsl_assert_data_9.blocking = 1;
    __gen_e_acsl_assert_data_9.kind = "Assertion";
    __gen_e_acsl_assert_data_9.pred_txt = "!\\valid(larr[0].t.p) && \\valid(larr[0].t.q)";
    __gen_e_acsl_assert_data_9.file = "tests/temporal/t_struct.c";
    __gen_e_acsl_assert_data_9.fct = "main";
    __gen_e_acsl_assert_data_9.line = 50;
    __e_acsl_assert(__gen_e_acsl_and_22,& __gen_e_acsl_assert_data_9);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_9);
  }
  /*@ assert !\valid(larr[0].t.p) && \valid(larr[0].t.q); */ ;
  __retres = 0;
  __e_acsl_delete_block((void *)(larr));
  __e_acsl_delete_block((void *)(& lp));
  __e_acsl_delete_block((void *)(& l));
  __e_acsl_delete_block((void *)(tarr));
  __e_acsl_delete_block((void *)(& t2));
  __e_acsl_delete_block((void *)(& t1));
  __e_acsl_delete_block((void *)(& a));
  __e_acsl_memory_clean();
  return __retres;
}


